//+----------------------------------------------------------------------------+
//|                                                        i-IBProfit_v01.mq4  |
//|                                                                            |
//|                                . aka KimIV,  http://www.kimiv.ru  |
//|                                                                            |
//|  07.02.2012      .               |
//|  09.02.2012  v01   Devide Zero   .|
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"
#property indicator_chart_window

//-------    ----------------------------------------+
extern string _P_Indicator   = "-----   ";
extern int      eiPercent    = 0;      //    :
                                       //  0 -  
                                       //  1 -    
                                       //  2 -    
                                       //  3 -    
                                       //  4 -    
                                       //  5 -    
                                       //  6 -    
extern datetime edUserDate  = D'2011.12.01';     //  
extern bool     PrintEnable = True;              //    
extern bool     AllMessages = False;             //   

extern string _P_Profit              = "-----   ";
extern bool     ebProfitShow         = True;          //  
extern bool     ebProfitShowTitle    = True;          //   
extern bool     ebProfitTransparent  = False;         //   
extern bool     ebProfitShowNumberOf = True;          //   
extern bool     ebProfitShowPoints   = True;          //   
extern bool     ebProfitShowLots     = True;          //   
extern bool     ebProfitShowCurrency = True;          //   
extern bool     ebProfitShowPercent  = True;          //   
extern string   esProfitShowLines    = "11111011";    //   
extern string   esProfitSymbols      = ";gbpusd";     // ,     
extern int      eiProfitX            = 5;             //  X  
extern int      eiProfitY            = 25;            //  Y  
extern int      eiProfitXStep        = 0;             //   X   
extern int      eiProfitYStep        = 125;           //   Y   
extern color    ecProfitBack         = WhiteSmoke;    //   
extern color    ecProfitHeader       = Navy;          //  
extern color    ecProfitText         = Gray;          //  
extern color    ecProfitProfit       = Green;         //  
extern color    ecProfitLoss         = Red;           //  

//-------    ------------------------------------+
double gdBeginBalance;  //  

//-------   ------------------------------------------------------+
int    giHOTI[];        //  
string gsHOSY[];        //   
int    giHOTY[];        //  
double gdHOLO[];        //  
double gdHOCO[];        //    
double gdHOOP[];        //  
int    giHOOT[];        //  
double gdHOCP[];        //  
int    giHOCT[];        //  
double gdHOPR[];        //    
double gdHOSW[];        //    
int    giHOMN[];        //  ()
double gdHODD[];        //    

//-------    ----------------------------------------------+
int    giPOTI[];        //  
string gsPOSY[];        //   
int    giPOTY[];        //  
double gdPOLO[];        //  
double gdPOCO[];        //    
double gdPOOP[];        //  
int    giPOOT[];        //  
double gdPOPR[];        //    
double gdPOSW[];        //    
int    giPOMN[];        //  ()
double gdPODD[];        //    

//-------   ---------------------------------------------------+

//-------    ------------------------------------------+


//+----------------------------------------------------------------------------+
//|  Custom indicator initialization function                                  |
//+----------------------------------------------------------------------------+
void init() {}

//+----------------------------------------------------------------------------+
//|  Custom indicator iteration function                                       |
//+----------------------------------------------------------------------------+
void start() {
  Main();
}

//+----------------------------------------------------------------------------+
//|  Custom indicator deinitialization function                                |
//+----------------------------------------------------------------------------+
void deinit() {
  int in=UninitializeReason();
  if (in==REASON_PARAMETERS || in==REASON_REMOVE || in==REASON_RECOMPILE) {
    ObjectsDeleteAll();
    Comment("");
  }
}


//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 03.02.2012                                                     |
//|   :      .   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    va[][] -                                                     |
//|    st     -                                             |
//+----------------------------------------------------------------------------+
void ArrayInitString(string& va[][], string st="") {
  int i, k=ArrayRange(va, 0);
  int j, m=ArrayRange(va, 1);

  for (i=0; i<k; i++) {
    for (j=0; j<m; j++) va[i][j]=st;
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 17.01.2012                                                     |
//|   :       .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    va[][]    -                        |
//|    eX[]      -   X                               |
//|    eY[]      -   Y                               |
//|    ibSize[]  -   (/)                                  |
//|    ShowTitle -                                        |
//+----------------------------------------------------------------------------+
void CalcSizeIB(string& va[][], int& eX[], int& eY[], int& ibSize[], bool ShowTitle=True) {
  int nc, nl;      //  , 
  int i, j;        //   , 
  int x, y;        //  XY  
  int sy=12;       //   Y       -          
  int wf=6;        //   /
  int w[];         //     

  nc=ArrayRange(va, 1);      //       
  nl=ArrayRange(va, 0);      //       

  //     
  for (i=0; i<nc; i++) {          // 
    if (StringLen(va[0][i])==0) {
      nc=i;
      break;
    }
  }
  for (j=0; j<nl; j++) {          // 
    if (StringLen(va[j][0])==0) {
      nl=j;
      break;
    }
  }

  ArrayResize(eX, nc);            //   
  ArrayResize(eY, nl);            //   
  ArrayResize(w , nc);            //   
  ArrayInitialize(eX, 0);
  ArrayInitialize(eY, 0);
  ArrayInitialize(w, 0);

  //       
  for (i=0; i<nc; i++) {          // 
    for (j=0; j<nl; j++) {        // 
      if (StringLen(va[j][i])>w[i]) w[i]=StringLen(va[j][i]);
    }
  }

  //     
  x=5;
  if (ShowTitle) y=20; else y=5;
  eX[0]=x;
  for (i=1; i<nc; i++) eX[i]=eX[i-1]+5.8*MathExp(1.0/w[i-1])*w[i-1]+5;
  for (j=0; j<nl; j++) eY[j]=y+j*sy;

  //  
  ibSize[0]=eX[nc-1]+wf*w[nc-1]+x;
  ibSize[1]=eY[nl-1]+sy+1;
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 18.01.2012                                                     |
//|   :   ,    .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    id -                                              |
//|    xy -   XY                                       |
//+----------------------------------------------------------------------------+
void CheckExistIB(string nm, int& xy[]) {
  if (ObjectFind(nm)>=0) {
    xy[0]=ObjectGet(nm, OBJPROP_XDISTANCE);
    xy[1]=ObjectGet(nm, OBJPROP_YDISTANCE);
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.05.2008                                                     |
//|   :                                    |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|                                    (-2 - )                      |
//|                                    (-1 - )                          |
//|    no -               ( 0 - )                          |
//|                                    ( 1 - )                        |
//|                                    ( 2 - )                      |
//+----------------------------------------------------------------------------+
datetime DateBeginQuarter(int nk=0) {
  int ye=Year()-MathFloor(nk/4);
  nk=MathMod(nk, 4);
  int mo=Month()-MathMod(Month()+2, 3)+3*nk;
  if (mo<1) {
    mo+=12;
    ye--;
  }
  if (mo>12) {
    mo-=12;
    ye++;
  }

  return(StrToTime(ye+"."+mo+".01"));
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.05.2008                                                     |
//|   :                                      |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|                                    (-2 -  )                   |
//|                                    (-1 -  )                   |
//|    no -           ( 0 -  )                   |
//|                                    ( 1 - ,  )     |
//|                                    ( 2 - )                      |
//+----------------------------------------------------------------------------+
datetime DateOfMonday(int no=0) {
  datetime dt=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE));

  while (TimeDayOfWeek(dt)!=1) dt-=24*60*60;
  dt+=no*7*24*60*60;

  return(dt);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 20.01.2012                                                     |
//|   :     .                           |
//|                 .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    dt -       1970   (0 -   )        |
//+----------------------------------------------------------------------------+
double GetBalanceOnDateM(datetime dt=0)
{
  double p=AccountBalance()-GetChangeBalanceM(dt)
          -GetProfitFromDateInCurrencyM("", -1, -1, dt);
  return(p);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 30.04.2010                                                     |
//|   :           |
//|             (, ,  ).                     |
//|                 .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    dt -       1970   (0 -   )        |
//+----------------------------------------------------------------------------+
double GetChangeBalanceM(datetime dt=0)
{
  double p=0;
  int    i, k=ArraySize(giHOTI);

  for (i=0; i<k; i++) {
    if (giHOTY[i]==6) {
      if (dt<giHOCT[i]) p+=gdHOPR[i];
    }
  }
  return(p);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 20.01.2012                                                     |
//|   :                     |
//|                                                                 |
//|                 .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -               (""   -  ,         |
//|                                               NULL -  )       |
//|    op -                              (-1   -  )        |
//|    mn - MagicNumber                          (-1   -  )          |
//|    dt -       1970   ( 0   -   )     |
//+----------------------------------------------------------------------------+
double GetLotFromDateM(string sy="", int op=-1, int mn=-1, datetime dt=0) {
  double p=0;
  int i, k=ArraySize(giHOTI);

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if ((gsHOSY[i]==sy || sy=="") && (op<0 || giHOTY[i]==op)) {
      if (giHOTY[i]==OP_BUY || giHOTY[i]==OP_SELL) {
        if (mn<0 || giHOMN[i]==mn) {
          if (dt<giHOCT[i]) p+=gdHOLO[i];
        }
      }
    }
  }
  return(p);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV  Kordan,  http://www.kimiv.ru          |
//+----------------------------------------------------------------------------+
//|     : 20.01.2012                                                     |
//|   :                           |                                                            |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -               (""   -  ,         |
//|                                               NULL -  )       |
//|    op -                              (-1   -  )        |
//|    mn - MagicNumber                          (-1   -  )          |
//+----------------------------------------------------------------------------+
double GetLotOpenPosM(string sy="", int op=-1, int mn=-1) {
  double p=0;
  int    i, k=ArraySize(giPOTI);

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if ((gsPOSY[i]==sy || sy=="") && (op<0 || giPOTY[i]==op)) {
      if (giPOTY[i]==OP_BUY || giPOTY[i]==OP_SELL) {
        if (mn<0 || giPOMN[i]==mn) p+=gdPOLO[i];
      }
    }
  }
  return(p);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.01.2012                                                     |
//|   :                        |
//|                                            |
//|                 .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -               (""   -  ,         |
//|                                               NULL -  )       |
//|    op -                              (-1   -  )        |
//|    mn - MagicNumber                          (-1   -  )          |
//|    dt -       1970   ( 0   -   )     |
//+----------------------------------------------------------------------------+
double GetProfitFromDateInCurrencyM(string sy="", int op=-1, int mn=-1, datetime dt=0)
{
  double p=0;
  int    i, k=ArraySize(giHOTI);

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if ((gsHOSY[i]==sy || sy=="") && (op<0 || giHOTY[i]==op)) {
      if (giHOTY[i]==OP_BUY || giHOTY[i]==OP_SELL) {
        if (mn<0 || giHOMN[i]==mn) {
          if (dt<giHOCT[i]) p+=gdHOPR[i]+gdHOCO[i]+gdHOSW[i];
        }
      }
    }
  }
  return(p);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.01.2012                                                     |
//|   :                               |
//|                 .                          |
//|                 .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -               (""   -  ,         |
//|                                               NULL -  )       |
//|    op -                              (-1   -  )        |
//|    mn - MagicNumber                          (-1   -  )          |
//|    dt -       1970   ( 0   -   )     |
//+----------------------------------------------------------------------------+
double GetProfitFromDateInPointM(string sy="", int op=-1, int mn=-1, datetime dt=0)
{
  double p=0, po;
  int    i, k=ArraySize(giHOTI);

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if ((gsHOSY[i]==sy || sy=="") && (op<0 || giHOTY[i]==op)) {
      if (giHOTY[i]==OP_BUY || giHOTY[i]==OP_SELL) {
        if (mn<0 || giHOMN[i]==mn) {
          if (dt<giHOCT[i]) {
            po=MarketInfo(gsHOSY[i], MODE_POINT);
            if (po==0) Message("     "+gsHOSY[i]+".    !");
            else {
              if (giHOTY[i]==OP_BUY) {
                p+=(gdHOCP[i]-gdHOOP[i])/po;
              }
              if (giHOTY[i]==OP_SELL) {
                p+=(gdHOOP[i]-gdHOCP[i])/po;
              }
            }
          }
        }
      }
    }
  }
  return(p);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 20.01.2012                                                     |
//|   :         |
//|                 .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
double GetProfitOpenPosInCurrencyM(string sy="", int op=-1, int mn=-1) {
  double p=0;
  int    i, k=ArraySize(giPOTI);

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if ((gsPOSY[i]==sy || sy=="") && (op<0 || giPOTY[i]==op)) {
      if (giPOTY[i]==OP_BUY || giPOTY[i]==OP_SELL) {
        if (mn<0 || giPOMN[i]==mn) {
          p+=gdPOPR[i]+gdPOCO[i]+gdPOSW[i];
        }
      }
    }
  }
  return(p);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 20.01.2012                                                     |
//|   :                |
//|                 .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
int GetProfitOpenPosInPointM(string sy="", int op=-1, int mn=-1) {
  double p;
  int    i, k=ArraySize(giPOTI), pr=0;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if ((gsPOSY[i]==sy || sy=="") && (op<0 || giPOTY[i]==op)) {
      if (mn<0 || giPOMN[i]==mn) {
        p=MarketInfo(gsPOSY[i], MODE_POINT);
        if (p==0) Message("     "+gsHOSY[i]+".    !");
        else {
          if (giPOTY[i]==OP_BUY) {
            pr+=(MarketInfo(gsPOSY[i], MODE_BID)-gdPOOP[i])/p;
          }
          if (giPOTY[i]==OP_SELL) {
            pr+=(gdPOOP[i]-MarketInfo(gsPOSY[i], MODE_ASK))/p;
          }
        }
      }
    }
  }
  return(pr);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 21.01.2012                                                     |
//|   :    ()     .  |
//|                X  .                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    Transparent -                                       |
//|    ibSize[]    -   (/)                                |
//|    eX[]        -   X                             |
//+----------------------------------------------------------------------------+
string GetTextBack(bool Transparent, int& ibSize[], int& eX[]) {
  string st="";              //   ()
  int    h=ibSize[1];        //  
  int    i, ks;              //    
  int    d;                  //    
  int    k;                  //  

  if (Transparent) {         //   
    ks=ibSize[0]*2.6/h;
    for (i=0; i<ks; i++) st=st+" ";
    d=ibSize[0];
    ibSize[0]=ks*h/2.0;     //   
    d=ibSize[0]-d;           //   
  } else {                   //   
    ks=MathCeil(1.0*ibSize[0]/h);
    for (i=0; i<ks; i++) st=st+"g";
    d=ibSize[0];
    ibSize[0]=ks*h;          //   
    d=ibSize[0]-d;           //   
  }

  k=ArraySize(eX);
  if (k>1) {                 //   2  
    eX[k-1]+=d;              //       
    if (k>2) {               //   3  
      d/=(k-1);              //       
      for (i=1; i<k-1; i++) eX[i]+=d*i;
    }
  }
  return(st);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 16.01.2012                                                     |
//|   :    .                           |
//|                start() ,   |
//+----------------------------------------------------------------------------+
void Main() {
  datetime db;     //   
  ReadHistory();
  ReadPositions();

  switch (eiPercent) {
    case 0:
      db=TimeCurrent();
      break;
    case 1:
      db=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE));
      while (TimeDayOfWeek(db)<1 || TimeDayOfWeek(db)>5) db-=24*60*60;
      db=db-24*60*60;
      break;
    case 2:
      db=DateOfMonday();
      break;
    case 3:
      db=StrToTime(Year()+"."+Month()+".01");
      break;
    case 4:
      db=DateBeginQuarter();
      break;
    case 5:
      db=StrToTime(Year()+".01.01");
      break;
    case 6:
      db=edUserDate;
      break;
  }
  gdBeginBalance=GetBalanceOnDateM(db);

  if (gdBeginBalance>0) if (ebProfitShow) ShowIBProfit();

  WindowRedraw();
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  static string prevMessage="";
  Comment(m);
  if (StringLen(m)>0 && PrintEnable) {
    if (AllMessages || prevMessage!=m) {
      prevMessage=m;
      Print(m);
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 20.01.2012                                                     |
//|   :       .    |
//|                 .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -               (""   -  ,         |
//|                                               NULL -  )       |
//|    op -                              (-1   -  )        |
//|    mn - MagicNumber                          (-1   -  )          |
//|    dt -       1970   ( 0   -   )     |
//+----------------------------------------------------------------------------+
int NumberOfPosFromDateM(string sy="", int op=-1, int mn=-1, datetime dt=0) {
  int i, k=ArraySize(giHOTI), kp=0;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (gsHOSY[i]==sy || sy=="") {
      if (giHOTY[i]==OP_BUY || giHOTY[i]==OP_SELL) {
        if ((op<0 || giHOTY[i]==op) && (mn<0 || giHOMN[i]==mn)) {
          if (dt<giHOCT[i]) kp++;
        }
      }
    }
  }
  return(kp);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 20.01.2012                                                     |
//|   :    .                         |
//|                 .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
int NumberOfPositionsM(string sy="", int op=-1, int mn=-1) {
  int i, k=ArraySize(giPOTI), kp=0;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (gsPOSY[i]==sy || sy=="") {
      if (giPOTY[i]==OP_BUY || giPOTY[i]==OP_SELL) {
        if (op<0 || giPOTY[i]==op) {
          if (mn<0 || giPOMN[i]==mn) kp++;
        }
      }
    }
  }
  return(kp);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 16.01.2012                                                     |
//|   :   .   .         |
//+----------------------------------------------------------------------------+
void ReadHistory() {
  int i, k=OrdersHistoryTotal(), r;

  ArrayResize(giHOTI, 0);    //  
  ArrayResize(gsHOSY, 0);    //   
  ArrayResize(giHOTY, 0);    //   (Buy/Sell)
  ArrayResize(gdHOLO, 0);    //  
  ArrayResize(gdHOCO, 0);    //    
  ArrayResize(gdHOOP, 0);    //  
  ArrayResize(giHOOT, 0);    //  
  ArrayResize(gdHOCP, 0);    //  
  ArrayResize(giHOCT, 0);    //  
  ArrayResize(gdHOPR, 0);    //    
  ArrayResize(gdHOSW, 0);    //    
  ArrayResize(giHOMN, 0);    //  ()
  ArrayResize(gdHODD, 0);    //    

  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderType()==OP_BUY || OrderType()==OP_SELL || OrderType()==6) {
        r=ArraySize(giHOTI);
        ArrayResize(giHOTI, r+1);
        ArrayResize(gsHOSY, r+1);
        ArrayResize(giHOTY, r+1);
        ArrayResize(gdHOLO, r+1);
        ArrayResize(gdHOCO, r+1);
        ArrayResize(gdHOOP, r+1);
        ArrayResize(giHOOT, r+1);
        ArrayResize(gdHOCP, r+1);
        ArrayResize(giHOCT, r+1);
        ArrayResize(gdHOPR, r+1);
        ArrayResize(gdHOSW, r+1);
        ArrayResize(giHOMN, r+1);
        ArrayResize(gdHODD, r+1);
        giHOTI[r]=OrderTicket();
        gsHOSY[r]=OrderSymbol();
        giHOTY[r]=OrderType();
        gdHOLO[r]=OrderLots();
        gdHOCO[r]=OrderCommission();
        gdHOOP[r]=OrderOpenPrice();
        giHOOT[r]=OrderOpenTime();
        gdHOCP[r]=OrderClosePrice();
        giHOCT[r]=OrderCloseTime();
        gdHOPR[r]=OrderProfit();
        gdHOSW[r]=OrderSwap();
        giHOMN[r]=OrderMagicNumber();
        gdHODD[r]=0;
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 16.01.2012                                                     |
//|   :     .                          |
//|               .                                |
//+----------------------------------------------------------------------------+
void ReadPositions() {
  int i, k=OrdersTotal(), r;

  ArrayResize(giPOTI, 0);    //  
  ArrayResize(gsPOSY, 0);    //   
  ArrayResize(giPOTY, 0);    //   (Buy/Sell)
  ArrayResize(gdPOLO, 0);    //  
  ArrayResize(gdPOCO, 0);    //    
  ArrayResize(gdPOOP, 0);    //  
  ArrayResize(giPOOT, 0);    //  
  ArrayResize(gdPOPR, 0);    //    
  ArrayResize(gdPOSW, 0);    //    
  ArrayResize(giPOMN, 0);    //  ()
  ArrayResize(gdPODD, 0);    //    

  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS)) {
      if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
        r=ArraySize(giPOTI);
        ArrayResize(giPOTI, r+1);
        ArrayResize(gsPOSY, r+1);
        ArrayResize(giPOTY, r+1);
        ArrayResize(gdPOLO, r+1);
        ArrayResize(gdPOCO, r+1);
        ArrayResize(gdPOOP, r+1);
        ArrayResize(giPOOT, r+1);
        ArrayResize(gdPOPR, r+1);
        ArrayResize(gdPOSW, r+1);
        ArrayResize(giPOMN, r+1);
        ArrayResize(gdPODD, r+1);
        giPOTI[r]=OrderTicket();
        gsPOSY[r]=OrderSymbol();
        giPOTY[r]=OrderType();
        gdPOLO[r]=OrderLots();
        gdPOCO[r]=OrderCommission();
        gdPOOP[r]=OrderOpenPrice();
        giPOOT[r]=OrderOpenTime();
        gdPOPR[r]=OrderProfit();
        gdPOSW[r]=OrderSwap();
        giPOMN[r]=OrderMagicNumber();
        gdPODD[r]=0;
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 18.01.2012                                                     |
//|   :   ,  OBJ_LABEL.                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    nm -                                                 |
//|    tx -                                                               |
//|    cl -                                                           |
//|    xd -  X                                              |
//|    yd -  Y                                              |
//|    cr -           (0 -  ,                     |
//|                                     1 -  ,                    |
//|                                     2 -  ,                      |
//|                                     3 -   )                    |
//|    fs -                (9 -    )                    |
//|    fn -      (Arial -    )                    |
//+----------------------------------------------------------------------------+
void SetLabel(string nm, string tx, color cl, int xd, int yd, int cr=0, int fs=9, string fn="Arial") {
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, 0, 0,0);
  ObjectSetText(nm, tx, fs, fn);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_XDISTANCE, xd);
  ObjectSet(nm, OBJPROP_YDISTANCE, yd);
  ObjectSet(nm, OBJPROP_CORNER   , cr);
  ObjectSet(nm, OBJPROP_FONTSIZE , fs);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 20.01.2012                                                     |
//|   :    "".                       |
//+----------------------------------------------------------------------------+
void ShowIBProfit() {
  datetime d0, d1, d2, d3, d4, d5, d6;
  double   p0, p1, p2, p3, p4, p5, p6, p7;
  string   id[2];       //    
  bool     pa[3];       //   (ShowTitle, Transparent, ExistHeader)
  string   va[9][6];    //      
  int      xy[2];       //  XY 
  color    co[5];       //  
  string   sy[];        //   ( )
  bool     ss[];        //   
  int      n;           //  
  int      i, k;        //    
  int      s;           //  

  d0=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE));
  while (TimeDayOfWeek(d0)<1 || TimeDayOfWeek(d0)>5) d0-=24*60*60;
  d1=d0-24*60*60;
  d2=DateOfMonday();
  d3=StrToTime(Year()+"."+Month()+".01");
  d4=DateBeginQuarter();
  d5=StrToTime(Year()+".01.01");
  d6=edUserDate;

  pa[0]=ebProfitShowTitle;        //   
  pa[1]=ebProfitTransparent;      //  
  pa[2]=True;                     //    

  co[0]=ecProfitBack;             //   
  co[1]=ecProfitHeader;           //  
  co[2]=ecProfitText;             //  
  co[3]=ecProfitProfit;           //  
  co[4]=ecProfitLoss;             //  

  ArrayInitString(va);
  StrToArrayBool(esProfitShowLines, ss);
  k=StrSplit(StringUpper(esProfitSymbols), sy, ";");
  for (i=0; i<k; i++) {
    id[0]="Pr"+sy[i];
    id[1]=" "+sy[i];

    n=0; va[0][0]="     ---";
    if (ss[0]) { va[n+1][0]=""; n++; }
    if (ss[1]) { va[n+1][0]=""; n++; }
    if (ss[2]) { va[n+1][0]=""; n++; }
    if (ss[3]) { va[n+1][0]=" . "; n++; }
    if (ss[4]) { va[n+1][0]=" . "; n++; }
    if (ss[5]) { va[n+1][0]=" ."; n++; }
    if (ss[6]) { va[n+1][0]=" . "; n++; }
    if (ss[7]) { va[n+1][0]=" "+TimeToStr(d6, TIME_DATE); n++; }

    s=1;
    if (ebProfitShowNumberOf) {
      n=0; va[0][s]="-";
      p2=NumberOfPosFromDateM(sy[i], -1, -1, d0);
      if (ss[0]) { va[n+1][s]=DoubleToStr(NumberOfPositionsM  (sy[i]), 0); n++; }
      if (ss[1]) { va[n+1][s]=DoubleToStr(p2, 0); n++; }
      if (ss[2]) { va[n+1][s]=DoubleToStr(NumberOfPosFromDateM(sy[i], -1, -1, d1)-p2, 0); n++; }
      if (ss[3]) { va[n+1][s]=DoubleToStr(NumberOfPosFromDateM(sy[i], -1, -1, d2), 0); n++; }
      if (ss[4]) { va[n+1][s]=DoubleToStr(NumberOfPosFromDateM(sy[i], -1, -1, d3), 0); n++; }
      if (ss[5]) { va[n+1][s]=DoubleToStr(NumberOfPosFromDateM(sy[i], -1, -1, d4), 0); n++; }
      if (ss[6]) { va[n+1][s]=DoubleToStr(NumberOfPosFromDateM(sy[i], -1, -1, d5), 0); n++; }
      if (ss[7]) { va[n+1][s]=DoubleToStr(NumberOfPosFromDateM(sy[i], -1, -1, d6), 0); n++; }
      s++;
    }
    if (ebProfitShowPoints) {
      n=0; va[0][s]="";
      p2=GetProfitFromDateInPointM(sy[i], -1, -1, d0);
      if (ss[0]) { va[n+1][s]=DoubleToStr(GetProfitOpenPosInPointM (sy[i]), 0); n++; }
      if (ss[1]) { va[n+1][s]=DoubleToStr(p2, 0); n++; }
      if (ss[2]) { va[n+1][s]=DoubleToStr(GetProfitFromDateInPointM(sy[i], -1, -1, d1)-p2, 0); n++; }
      if (ss[3]) { va[n+1][s]=DoubleToStr(GetProfitFromDateInPointM(sy[i], -1, -1, d2), 0); n++; }
      if (ss[4]) { va[n+1][s]=DoubleToStr(GetProfitFromDateInPointM(sy[i], -1, -1, d3), 0); n++; }
      if (ss[5]) { va[n+1][s]=DoubleToStr(GetProfitFromDateInPointM(sy[i], -1, -1, d4), 0); n++; }
      if (ss[6]) { va[n+1][s]=DoubleToStr(GetProfitFromDateInPointM(sy[i], -1, -1, d5), 0); n++; }
      if (ss[7]) { va[n+1][s]=DoubleToStr(GetProfitFromDateInPointM(sy[i], -1, -1, d6), 0); n++; }
      s++;
    }
    if (ebProfitShowLots) {
      n=0; va[0][s]="";
      p2=GetLotFromDateM(sy[i], -1, -1, d0);
      if (ss[0]) { va[n+1][s]=DoubleToStr(GetLotOpenPosM (sy[i]), 2); n++; }
      if (ss[1]) { va[n+1][s]=DoubleToStr(p2, 2); n++; }
      if (ss[2]) { va[n+1][s]=DoubleToStr(GetLotFromDateM(sy[i], -1, -1, d1)-p2, 2); n++; }
      if (ss[3]) { va[n+1][s]=DoubleToStr(GetLotFromDateM(sy[i], -1, -1, d2), 2); n++; }
      if (ss[4]) { va[n+1][s]=DoubleToStr(GetLotFromDateM(sy[i], -1, -1, d3), 2); n++; }
      if (ss[5]) { va[n+1][s]=DoubleToStr(GetLotFromDateM(sy[i], -1, -1, d4), 2); n++; }
      if (ss[6]) { va[n+1][s]=DoubleToStr(GetLotFromDateM(sy[i], -1, -1, d5), 2); n++; }
      if (ss[7]) { va[n+1][s]=DoubleToStr(GetLotFromDateM(sy[i], -1, -1, d6), 2); n++; }
      s++;
    }
    if (ss[0]) p0=GetProfitOpenPosInCurrencyM (sy[i]);
    if (ss[1]) p1=GetProfitFromDateInCurrencyM(sy[i], -1, -1, d0);
    if (ss[2]) p2=GetProfitFromDateInCurrencyM(sy[i], -1, -1, d1)-p1;
    if (ss[3]) p3=GetProfitFromDateInCurrencyM(sy[i], -1, -1, d2);
    if (ss[4]) p4=GetProfitFromDateInCurrencyM(sy[i], -1, -1, d3);
    if (ss[5]) p5=GetProfitFromDateInCurrencyM(sy[i], -1, -1, d4);
    if (ss[6]) p6=GetProfitFromDateInCurrencyM(sy[i], -1, -1, d5);
    if (ss[7]) p7=GetProfitFromDateInCurrencyM(sy[i], -1, -1, d6);
    if (ebProfitShowCurrency) {
      n=0; va[0][s]="";
      if (ss[0]) { va[n+1][s]=DoubleToStr(p0, 2); n++; }
      if (ss[1]) { va[n+1][s]=DoubleToStr(p1, 2); n++; }
      if (ss[2]) { va[n+1][s]=DoubleToStr(p2, 2); n++; }
      if (ss[3]) { va[n+1][s]=DoubleToStr(p3, 2); n++; }
      if (ss[4]) { va[n+1][s]=DoubleToStr(p4, 2); n++; }
      if (ss[5]) { va[n+1][s]=DoubleToStr(p5, 2); n++; }
      if (ss[6]) { va[n+1][s]=DoubleToStr(p6, 2); n++; }
      if (ss[7]) { va[n+1][s]=DoubleToStr(p7, 2); n++; }
      s++;
    }
    if (ebProfitShowPercent) {
      n=0; va[0][s]="";
      if (ss[0]) { va[n+1][s]=DoubleToStr(p0*100/gdBeginBalance, 2); n++; }
      if (ss[1]) { va[n+1][s]=DoubleToStr(p1*100/gdBeginBalance, 2); n++; }
      if (ss[2]) { va[n+1][s]=DoubleToStr(p2*100/gdBeginBalance, 2); n++; }
      if (ss[3]) { va[n+1][s]=DoubleToStr(p3*100/gdBeginBalance, 2); n++; }
      if (ss[4]) { va[n+1][s]=DoubleToStr(p4*100/gdBeginBalance, 2); n++; }
      if (ss[5]) { va[n+1][s]=DoubleToStr(p5*100/gdBeginBalance, 2); n++; }
      if (ss[6]) { va[n+1][s]=DoubleToStr(p6*100/gdBeginBalance, 2); n++; }
      if (ss[7]) { va[n+1][s]=DoubleToStr(p7*100/gdBeginBalance, 2); n++; }
    }

    xy[0]=eiProfitX+eiProfitXStep*i;
    xy[1]=eiProfitY+eiProfitYStep*i;

    ShowInfoBlock(id, pa, va, xy, co);
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 16.01.2012                                                     |
//|   :  .                                            |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    id[]   -                                |
//|    pa[]   -   (ShowTitle, Transparent, LossColor)        |
//|    va[][] -                           |
//|    xy[]   -   XY                                            |
//|    co[]   -   (, , , )                   |
//+----------------------------------------------------------------------------+
void ShowInfoBlock(string& id[], bool& pa[], string& va[][], int& xy[], color& co[]) {
  bool   ShowTitle=pa[0];    //   
  bool   Transparent=pa[1];  //   
  bool   ExistHeader=pa[2];  //    
  color  cl;                 //   
  int    i, j;               //   , 
  int    eX[], eY[];         //   
  int    ibSize[2];          //   (/)
  string st;                 //   ()

  CalcSizeIB(va, eX, eY, ibSize, ShowTitle);
  // 
  CheckExistIB(id[0], xy);
  st=GetTextBack(Transparent, ibSize, eX);
  SetLabel(id[0], st, co[0], xy[0], xy[1], 0, ibSize[1]/1.3, "Webdings");
  // 
  if (ShowTitle) SetLabel(id[0]+"H", id[1], co[1], xy[0]+20, xy[1], 0, 12);
  //    
  for (i=0; i<ArraySize(eX); i++) {
    for (j=0; j<ArraySize(eY); j++) {
      if (i==0) cl=co[2]; else {
        if (ArraySize(co)>4) {
          if (StrToDouble(va[j][i])<0) cl=co[4]; else cl=co[3];
        }
        else cl=co[3];
      }
      if (ExistHeader && j==0) cl=co[2];
      SetLabel(id[0]+i+j, va[j][i], cl, xy[0]+eX[i], xy[1]+eY[j]);
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 03.02.2012                                                     |
//|   :    0/1    .   |
//+----------------------------------------------------------------------------+
//|  :                                                                  |
//|                                                 |
//|  :                                                                |
//|    st -   0/1                                                |
//|    ab -                                            |
//+----------------------------------------------------------------------------+
int StrToArrayBool(string st, bool& as[]) { 
  int i=0, k=StringLen(st);

  ArrayResize(as, k);
  for (i=0; i<k; i++) as[i]=StrToInteger(StringSubstr(st, i, 1));

  return(k);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
string StringUpper(string s) {
  int c, i, k=StringLen(s), n;
  for (i=0; i<k; i++) {
    n=0;
    c=StringGetChar(s, i);
    if (c>96 && c<123) n=c-32;    // a-z -> A-Z
    if (c>223 && c<256) n=c-32;   // - -> -
    if (c==184) n=168;            //    ->  
    if (n>0) s=StringSetChar(s, i, n);
  }
  return(s);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 20.01.2012                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                  |
//|                                                 |
//|  :                                                                |
//|    st -                                                |
//|    as -                                                     |
//|    de -                                                         |
//+----------------------------------------------------------------------------+
int StrSplit(string st, string& as[], string de=",") { 
  int    i=0, np;
  string stp;

  ArrayResize(as, 0);
  while (StringLen(st)>0) {
    np=StringFind(st, de);
    if (np<0) {
      stp=st;
      st="";
    } else {
      if (np==0) stp=""; else stp=StringSubstr(st, 0, np);
      st=StringSubstr(st, np+1);
    }
    i++;
    ArrayResize(as, i);
    as[i-1]=stp;
  }
  return(ArraySize(as));
}
//+----------------------------------------------------------------------------+

